config/routes.rb
Rails.application.routes.draw do
  devise_for :admins
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  devise_for :users

  root 'movies#index'

  resources :movies, only: [:index] do
    resources :showtimes, only: [:show]
  end

  resources :orders
  resources :cinemas, only: [:index]
  get '/movie/:id/orders' => 'orders#movie_order_review', as: 'movie_order_review'
end

app/models/admin.rb
class Admin < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cinema.rb
class Cinema < ActiveRecord::Base
  has_many :theaters
  belongs_to :city
end

app/models/city.rb
class City < ApplicationRecord
	has_many :cinemas
end

app/models/movie.rb
class Movie < ActiveRecord::Base
  has_many :showtimes, dependent: :destroy

  validates :runtime, numericality: { only_integer: true, :greater_than_or_equal_to => 0 }
  validates :rating, numericality: { only_integer: true, :greater_than_or_equal_to => 0, :less_than_or_equal_to => 5 }
end

app/models/order.rb
class Order < ActiveRecord::Base
  belongs_to :showtime
  belongs_to :theater
  belongs_to :movie
  belongs_to :user
  before_update :downcase_email

  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-]+(\.[a-z\d\-]+)*\.[a-z]+\z/i
  VALID_CREDIT_CARD_REGEX = /(^\d{15,16}$)/
  VALID_CVV_REGEX = /(^\d{3}$)/

  validates :email, presence: true,
                    on: :update,
                    length: { maximum: 255 },
                    format: { with: VALID_EMAIL_REGEX,
                              message: "- that email doesn't look right to us, check it again please." }

  validates :credit_card, presence: true,
                          on: :update,
                          length: { maximum: 16, minimum: 16 },
                          format: { with: VALID_CREDIT_CARD_REGEX,
                                    message: "- the card info doesn't look right to us. Check the length and make sure it's only numbers please." }

  validates :name, presence: true, on: :update
  validates :card_expiration_month, presence: true, on: :update
  validates :card_expiration_year,  presence: true, on: :update
  validates :cvv, presence: true,
                       on: :update,
                       length: { maximum: 3 },
                       format: { with: VALID_CVV_REGEX,
                                 message: "- CVV should only be 3 digits. No letters or extra numbers please."}
  validates :street_address, presence: true, on: :update
  validates :city, presence: true, on: :update
  validates :state, presence: true, on: :update

  private
    def downcase_email
      self.email = email.downcase
    end
end

app/models/showtime.rb
class Showtime < ActiveRecord::Base
  belongs_to :theater
  belongs_to :movie
  has_many :orders, dependent: :destroy

  def seats_remaining
    ticket_count = []
    theater_orders = Order.where(theater: self.theater)
    showtime_orders = theater_orders.where(showtime: self.id)

    showtime_orders.each do |order|
      ticket_count << order.tickets.to_i
    end
    tickets_sold = ticket_count.sum

    return self.theater.capacity - tickets_sold

    ticket_count.clear
  end
end

app/models/theater.rb
class Theater < ActiveRecord::Base
  has_many :showtimes, dependent: :destroy
  belongs_to :cinema
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
	devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :confirmable
    has_many :orders
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/cinemas_controller.rb
class CinemasController < ApplicationController
end

app/controllers/movies_controller.rb
class MoviesController < ApplicationController
  def index
    @movies = Movie.order(created_at: :desc)
    if params[movies_path]
      date = params[movies_path][:date].to_datetime
      @showtimes = Showtime.where(start_time: ((date.beginning_of_day + 5.hours)..(date.end_of_day + 5.hours)))
    else
      @showtimes = Showtime.where(start_time: ((Date.today.beginning_of_day + 5.hours)..(Date.today.end_of_day + 5.hours)))
    end
    respond_to do |format|
      format.js
      format.html
    end
  end

end

app/controllers/orders_controller.rb
class OrdersController < ApplicationController
  before_action :set_order_and_movie, only: [:show, :edit, :update, :destroy]
  before_action :order_params, only: [:create]
  before_action :authenticate_user!
  def index
    @orders = current_user.orders.all
    @movies = Movie.order(:created_at)
  end

  def create
    @order = current_user.orders.new(order_params)

    if @order.save
      redirect_to edit_order_path(@order)
    else
      render 'new', errors: @order.errors
    end
  end

  def show
  end

  def edit
  end

  def update 
    if @order.update(order_params)
      redirect_to @order, notice: 'Your purchase was successful.'
      OrderMailer.send_receipt(@order, @order.email).deliver_now
    else
      render 'edit'
    end
  end

  def destroy
    @order.destroy
    redirect_to movies_path, notice: 'Your order has been cancelled'
  end

  def movie_order_review
    @movie = Movie.find(params[:id])
  end

  private
    def set_order_and_movie
      @order = Order.find(params[:id])
      @movie = Movie.find(@order.movie_id)
    end

    def order_params
      params.require(:order).permit(:email, :name, :credit_card, :card_expiration_month, :card_expiration_year,
                                    :cvv, :tickets, :street_address, :city, :state, :zip_code, :country,
                                    :theater_id, :showtime_id, :movie_id)
    end
end

app/controllers/showtimes_controller.rb
class ShowtimesController < ApplicationController
  def show
    @showtime = Showtime.find(params[:id])
    @movie = Movie.find(params[:movie_id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cinemas_helper.rb
module CinemasHelper
end

app/helpers/movies_helper.rb
module MoviesHelper
  def verify_age(movie, showtime_id)
    age_params_hash = params[movie_showtime_path(movie.id, showtime_id)]
    if age_params_hash.nil?
      movie.rating == "R" || movie.rating == "PG-13" ? true : false
    end
  end

  def age_check_passes?(movie, showtime_id)
    age_params_hash = params[movie_showtime_path(movie.id, showtime_id)]
    if age_params_hash.nil?
      return true
    else
      birthdate_array = []
      age_day = age_params_hash[:age_day]
      age_month = age_params_hash[:age_month]
      age_year = age_params_hash[:age_year]
      birthdate_array << age_day << age_month << age_year
      birthdate_time = birthdate_array.join("/").to_time

      case movie.rating
      when "PG-13"
        13.years.ago.to_time >= birthdate_time ? true : false
      when "R"
        17.years.ago.to_time >= birthdate_time ? true : false
      end
    end
  end
end

app/helpers/orders_helper.rb
module OrdersHelper
  def ticket_price(showtime)
    case
    when showtime.start_time.hour <= 11
      return 7.5
    when showtime.start_time.hour > 11 && showtime.start_time.hour < 18
      return 10
    when showtime.start_time.hour >= 18
      return 9
    end
  end

  def order_subtotal(showtime, num_of_tickets)
    ticket_price(showtime) * num_of_tickets.to_i
  end

  def order_tax(showtime, num_of_tickets)
    (order_subtotal(showtime, num_of_tickets) * 0.0975).round(2)
  end

  def order_total(showtime, num_of_tickets)
    order_subtotal(showtime, num_of_tickets) + order_tax(showtime, num_of_tickets)
  end
end

app/helpers/showtimes_helper.rb
module ShowtimesHelper
  def format_showtime(showtime)
    showtime.start_time.hour < 12 ?
    "#{showtime.start_time.strftime("%A")} #{showtime.start_time.strftime("%-l:%M")}am" :
    "#{showtime.start_time.strftime("%A")} #{showtime.start_time.strftime("%-l:%M")}pm"
  end

  def format_showtime_without_day(showtime)
    showtime.start_time.hour < 12 ?
    "#{showtime.start_time.strftime("%-l:%M")}am" :
    "#{showtime.start_time.strftime("%-l:%M")}pm"
  end

  def sold_out(showtime)
    showtime.seats_remaining == 0 ? true : false
  end
end

app/views/admins/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider) %><br />
  <% end -%>
<% end -%>

app/views/cinemas/index.html.erb
<nav style=" background-color: black;  margin-top: -10px !important;">
    <ul class="nav nav-pills" style="text-align: center;">
	    <li class="active"><a data-toggle="pill" href="#sG">Nam Sai Gon</a></li>
	    <li><a data-toggle="pill" href="#nowZone">Now Zone</a></li>
	  </ul>
</nav>
<div class="tab-content">
	<div id="sG" class="tab-pane fade in active">
		<% nSG = Cinema.find_by(name: "Nam Sài Gòn")%>
		<%= image_tag nSG.image, class: "img-responsive"%>
		<div>
			<h2><strong><%=nSG.name%></strong></h2>
		</div>
		<div class="col-lg-offset-1">
			<h4>Address: <%=nSG.address%></h4>
		</div>
		<div class="col-lg-offset-1">
			<h4>Phone: <%=nSG.phone%></h4>
		</div>
		<div class="col-lg-offset-1">
			<h4>Total theaters: <%=nSG.theaters.count%></h4>
		</div>
		<iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d3919.9174260278533!2d106.70017291423659!3d10.740847392345696!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x31752f9f3904fc6d%3A0xf8eedeab7440a13a!2sLotte+Cinema+Nam+Sai+Gon!5e0!3m2!1svi!2s!4v1543471297862" width="100%" height="auto" frameborder="0" style="border:0" allowfullscreen></iframe>
		
	</div>
	<div id="nowZone" class="tab-pane fade in">
		<% nZone = Cinema.find_by(name: "Nowzone")%>
		<%= image_tag nZone.image, class: "img-responsive"%>
		<div>
			<h2><strong><%=nZone.name%></strong></h2>
		</div>
		<div class="col-lg-offset-1">
			<h4>Address: <%=nZone.address%></h4>
		</div>
		<div class="col-lg-offset-1">
			<h4>Phone: <%=nZone.phone%></h4>
		</div>
		<div class="col-lg-offset-1">
			<h4>Total theaters: <%=nZone.theaters.count%></h4>
		</div>
		<iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d3919.6125897852467!2d106.68031834979523!3d10.76431119229209!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x31752f19358a688d%3A0x950e00fb59d5e2db!2sLotte+Cinema+Nowzone!5e0!3m2!1svi!2s!4v1543471233241" width="100%" height="auto" frameborder="0" style="border:0" allowfullscreen></iframe>
	</div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
    <head>
        <title>Lotte - Cinema</title>    
        <link rel="icon" href="assets/images/logo.png"/>
        <%= stylesheet_link_tag  'application', media: 'all', 'data-turbolinks-track': 'reload' %>
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">
        <link href='http://fonts.googleapis.com/css?family=Lora|Open+Sans:400,300,700' rel='stylesheet' type='text/css'>
        <!-- Latest compiled and minified CSS -->
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

        <!-- Optional theme -->
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">

        <!-- Latest compiled and minified JavaScript -->
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
        <%= javascript_include_tag 'application', 'data-no-turbolinks-track': 'reload' %>
        <%= csrf_meta_tags %>

    </head>
  <body>
    <% unless flash.empty? %>
        <div class="flash-container">
            <%= render 'shared/flash_messages' %>
        </div>
    <% end %>

    <div class="body-panel">
        <div class="row">
            <div class="col-lg-12 col-xs-12 text-center header-logo">
                <%= link_to image_tag("logo1.gif", class: "img-responsive center-block"), root_path%>
            </div>
            <div class="col-lg-12 text-center">
                <nav style=" background-color: #dad2b4;">
                    <div class="navbar-header">
                        <a class="navbar-brand clearfix visible-xs-block visible-sm-block" href="#">Menu</a>
                        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#myNavbar">
                            <span class="icon-bar" style="background-color: black"></span>
                            <span class="icon-bar" style="background-color: black"></span>
                            <span class="icon-bar" style="background-color: black"></span>    
                        </button>
                    </div>
                    <div class="collapse navbar-collapse visible-lg-block clearfix" id="myNavbar">
                        <ul class="nav-links" style="font-size: 20px; padding-bottom: 10px; padding-top: 10px;" >
                            <li><%= link_to "Movie", root_path %></li>
                            <li><%= link_to "Cinema", cinemas_path %></li>
                            <li><%= link_to "Booking", orders_path %></li>
                            <% if user_signed_in? %>
                                <li><%= link_to "Member", edit_user_registration_path %></li>
                            <%else%>
                                <li><%= link_to "Member", new_user_session_path %></li>
                            <%end%>
                            <% if user_signed_in? %>
                                <%= link_to(destroy_user_session_path, {"data-hover" => "Log out" , method: :delete}) do %>
                                    Logout<span class="glyphicon glyphicon-log-in"></span>
                                <% end %>
                            <% else %>
                                <li><a><span class="glyphicon glyphicon-user"></span></a>&nbsp<%= link_to "Sign up", new_user_registration_path %></a></li>
                                <li><a><span class="glyphicon glyphicon-log-in"></span></a>&nbsp<%= link_to "Login", new_user_session_path %></a></li>
                            <%end%>
                        </ul>
                    </div>
                </nav>
            </div>
        </div>
        <%= yield %>
    </div>
    <footer>
        <div class="dn_footerl row">
            <ul style="list-style-type: none; font-size: 20px;" class="col-lg-offset-1 col-sm-offset-1 col-md-offset-1 col-sm-11 col-md-11">
                <li class="dn_textup"> Lotte Cinema Viet Nam</li>
                <li>
                    Tầng 3, TTTM Lotte, Số 469 đường Nguyễn Hữu Thọ, P.Tân Hưng, Q.7, Tp.Hồ Chí Minh, Việt Nam.
                </li>
                <li>
                    (028) 3775 2521 - (028) 3775 2520
                </li>
                <li>
                    <div class="dn_footerr " style="font-size: 20px;  display: inline;">
                        <p>Theo dõi:  
                            <a href="https://www.youtube.com/user/LotteCinemaVietnam" class=""><i class="fa fa-youtube fa-2x"></i></a>&nbsp&nbsp&nbsp
                            <a href="https://www.facebook.com/lottecinema"><i class="fa fa-facebook fa-2x"></i></a>
                        </p>
                        
                    </div>
                </li>
            </ul>
            <!--end dn_footerl-->
            
        </div>
        <div id="signate">
            <div class="col-lg-offset-5 col-md-offset-5 col-sm-offset-4 col-xs-offset-2">    
                <p>Khánh Dương © 2018 All Rights Reserved.</p>
            </div>
        </div>
    </footer>
  </body>
</html>

app/views/movies/_movie_thumbnail.html.erb
<div class="movie-thumbnail-image-index text-center">
    <%= image_tag movie.image, alt: movie.title, class: "movie-image img-responsive" %>
    <div class="movie-showtime-info">
        <h4 id="<%= dom_id movie %>_title"><%= movie.title %></h4>
        <div class="showtime-index" id="<%= dom_id movie %>_showtimes">
            <% if showtimes.empty? %>
                <p>No showtimes scheduled today</p>
            <% else %>
                <h4>Showtimes</h4>
                <% showtimes.each do |showtime| %>
                    <% if showtime.movie == movie %>
                        <div class="col-xs-6">
                            <p>
                                <% if sold_out(showtime) %>
                                    <span class="sold-out-showtime">Sold Out</span>
                                <% elsif  DateTime.strptime(showtime.start_time.strftime("%H:%M %Y/%m/%d"), "%H:%M %Y/%m/%d").to_i < DateTime.strptime(Time.now.strftime("%H:%M %Y/%m/%d"), "%H:%M %Y/%m/%d").to_i%>
                                    <span class="sold-out-showtime"></span>
                                <% elsif  DateTime.strptime(showtime.start_time.strftime("%H:%M %Y/%m/%d"), "%H:%M %Y/%m/%d").to_i >= DateTime.strptime(Time.now.strftime("%H:%M %Y/%m/%d"), "%H:%M %Y/%m/%d").to_i %>
                                    <%= link_to movie_showtime_path(movie, showtime), class: "showtime-link" do %>
                                        <%= format_showtime_without_day(showtime) %>
                                    <% end %>
                                
                                <% end %>
                            </p>
                        </div>
                    <%else%>
                        <p>No showtimes scheduled today</p>
                        <%break%>
                    <% end %>
                <% end %>
            <% end %>
        </div>
    </div>
</div>

app/views/movies/index.js.erb
<% @movies.each do |movie| %>
  	$('#<%= dom_id movie %>').html('<%= escape_javascript(render 'movie_thumbnail',
                                                                     movie: movie, showtimes: @showtimes) %>');
<% end %>


$('.movies-container').animate({ opacity: '100' }, 1000);

app/views/orders/_edit_form.html.erb
<%= form_for order, html: { class: "edit-ticket-order-form" } do |f| %>
  <% if order.errors.any? %>
    <%= render "shared/errors", resource: order %>
  <% end %>

  <div class="col-md-6">
    <div class="form-group">
      <%= f.label :email, class: "control-label" %>
      <%= f.email_field :email, class: "form-control" %>
    </div>

    <div class="form-group">
      <%= f.label :street_address, "Billing Street Address", class: "control-label" %>
      <%= f.text_field :street_address, class: "form-control", required: true %>
    </div>

    <div class="form-group">
      <%= f.label :city, class: "control-label" %>
      <%= f.text_field :city, class: "form-control", required: true %>
    </div>

    <div class="form-group">
      <%= f.label :state, class: "control-label" %>
      <%= f.text_field :state, class: "form-control", required: true %>
    </div>
  </div>

  <div class="col-md-6">
    <div class="form-group">
      <%= f.label :credit_card, "Credit Card", class: "control-label" %>
      <%= f.text_field :credit_card, class: "form-control" %>
    </div>

    <div class="form-group">
      <%= f.label :name, "Name on Credit Card", class: "control-label" %>
      <%= f.text_field :name, class: "form-control" %>
    </div>

    <div class="form-group row">
      <div class="col-xs-12">
        <%= f.label :card_expiration_month, "Expiration Date", class: "control-label" %>
      </div>
      <div class="col-xs-6">
        <%= f.select :card_expiration_month,
                     ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"],
                     { prompt: "Select a month..." }, class: "form-control" %>
       </div>

      <div class="col-xs-6">
        <%= f.select :card_expiration_year, [], { prompt: "Select a year..." }, { class: "form-control" } do %>
          <% 11.times do |n| %>
            <%= content_tag(:option, (Time.now.year) + n) %>
          <% end %>
        <% end %>
      </div>
    </div>

    <div class="form-group">
      <%= f.label :cvv, "CVV (3 digits on back of card)", class: "control-label" %>
      <%= f.text_field :cvv, class: "form-control", required: true %>
    </div>
  </div>

  <div class="col-xs-12 form-group text-center">
    <hr />

    <%= f.submit "Place Order", class: "btn btn-primary submit-ticket-order-button" %>
    or
    <%= link_to "Cancel order", order, method: :delete,
                data: { confirm: 'Are you sure you want to cancel this order?' } %>
  </div>
<% end %>

app/views/orders/_new_form.html.erb
<%= form_for order do |f| %>
  <% if order.errors.any? %>
    <%= render "shared/errors", resource: order %>
  <% end %>

  <div class="form-group col-md-5 ticket-select-field">
    <%= f.select :tickets, [], {}, { class: "form-control" } do %>
      <% showtime.seats_remaining.times do |number| %>
        <%= content_tag :option, (number + 1), value: (number + 1) %>
      <% end %>
    <% end %>
  </div>
  <%= f.hidden_field :theater_id,    value: showtime.theater.id %>
  <%= f.hidden_field :movie_id,    value: movie.id %>
  <%= f.hidden_field :showtime_id, value: params[:id] %>

  <div class="form-group">
    <%= f.submit "Order tickets", class: "btn btn-primary add-ticket-button" %>
  </div>
<% end %>

app/views/orders/index.html.erb
<div class="container">
    <div class="row text-center orders-table-type-header">
        <h3>Your orders</h3>
        
        <div class="row orders-index-header">
            <ul class="movie-order-review-list">
                <% @movies.each do |movie| %>
                    <li><%= link_to movie.title, movie_order_review_path(movie), class: "movie-review-link" %></li>
                <% end %>
            </ul>
        </div>
    </div>

    <div class="row">
        <table class="table table-hover orders-table">
            <tr>
                <th>Movie</th>
                <th>Showtimes</th>
                <th>Theater</th>
                <th>Amount</th>
                <th>Total (included tax)</th>
            </tr>
            <% @orders.each do |order| %>
                <tr>
                    <td data-th="Movie">
                        <%= link_to order_path(order), class: "order-table-link" do %>
                          <%= order.movie.title %>
                        <% end %>
                    </td>
                    <td data-th="Showtime">
                        <%= link_to order_path(order), class: "order-table-link" do %>
                            <%= format_showtime(order.showtime) %>
                        <% end %>
                    </td>
                    <td data-th="Theater Number">
                        <%= link_to order_path(order), class: "order-table-link" do %>
                            <%= order.theater.number %>
                        <% end %>
                    </td>
                    <td data-th="Number of Tickets">
                        <%= link_to order_path(order), class: "order-table-link" do %>
                            <%= order.tickets %>
                        <% end %>
                    </td>
                    <td data-th="Total (with tax)">
                        <%= link_to order_path(order), class: "order-table-link" do %>
                            <%= number_to_currency(order_total(order.showtime, order.tickets)) %>
                        <% end %>
                    </td>
                </tr>
            <% end %>
        </table>
    </div>

    <div class="row text-center">
        <p><%= link_to "<< Back to Movies", movies_path, class: "nav-links" %></p>
    </div>
</div>

app/views/orders/movie_order_review.html.erb
<div class="container">
  <div class="row text-center orders-table-type-header">
    <h3>Orders for <%= @movie.title %></h3>
  </div>
    <div class="row">
      <table class="table table-hover orders-table">
        <tr>
          <th>Showtime</th>
          <th>Theater Number</th>
          <th>Number of Tickets</th>
          <th>Total (with tax)</th>
        </tr>
        <% @movie.showtimes.each do |showtime| %>
          <% showtime.orders.each do |order| %>
            <tr>
              <td data-th="Showtime">
                <%= link_to order_path(order), class: "order-table-link" do %>
                  <%= format_showtime(order.showtime) %>
                <% end %>
              </td>
              <td data-th="Theater Number">
                <%= link_to order_path(order), class: "order-table-link" do %>
                  <%= order.theater.number %>
                <% end %>
              </td>
              <td data-th="Number of Tickets">
                <%= link_to order_path(order), class: "order-table-link" do %>
                  <%= order.tickets %>
                <% end %>
              </td>
              <td data-th="Total (with tax)">
                <%= link_to order_path(order), class: "order-table-link" do %>
                  <%= number_to_currency(order_total(order.showtime, order.tickets)) %>
                <% end %>
              </td>
            </tr>
          <% end %>
        <% end %>
      </table>
    </div>
  </div>

  <div class="row text-center">
    <p><%= link_to "<< Back to All Orders", orders_path, class: "nav-links" %></p>
  </div>
</div>

app/views/orders/show.html.erb
<div class="container">
  <% if request.referrer == edit_order_url(@order) %>
    <div class="row">
      <div class="col-xs-12">
        <h3>Thank you for your order! You'll receive an email confirmation shortly.</h3>
        <p>Tickets are will call or you can print your order confirmation and present it to the ticket taker.</p>
        <h4>Your order:</h4>
      </div>
    </div>
  <% end %>

  <hr />

  <div class="row">
    <div class="col-xs-12">
      <%= render 'order_summary', order: @order, movie: @movie %>
    </div>
  </div>

  <div class="row">
    <div class="col-xs-12 text-center">
      <%= link_to "I'm Done", movies_path, class: "btn btn-success back-to-movies-button" %>
    </div>
  </div>
</div>

app/views/shared/_errors.html.erb
<div class="alert alert-warning alert-dismissible" role="alert">
  <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
  <strong>
    <%= pluralize(resource.errors.count, "error") %> prohibited this machine from being saved:
  </strong>
  <ul>
    <% resource.errors.full_messages.each do |message| %>
      <li><small><%= message %></small></li>
    <% end %>
  </ul>
</div>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider) %><br />
  <% end -%>
<% end -%>